package org.jboss.qa.brms.traits;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;

public class TraitsTest {

    public static void main(String[] args) {
        new TraitsTest().test();
    }

    public void test() {
        KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
        kbuilder.add(ResourceFactory.newClassPathResource("traits.drl", getClass()), ResourceType.DRL);

        if (kbuilder.hasErrors()) {
            throw new RuntimeException(kbuilder.getErrors().toString());
        }

        KnowledgeBase kbase = kbuilder.newKnowledgeBase();
        StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();

        String name = "fat ugly builder";
        ksession.insert(name);
        Person worker = new Person(name, 30);
        ksession.insert(worker);

        String name2 = "working student";
        ksession.insert(name2);
        Person ws = new Person(name2, 22);
        ksession.insert(ws);

        Person student = new Person("student", 18);
        ksession.insert(student);

        System.out.println("Starting execution...");

        ksession.fireAllRules();

        /*
        System.out.println("Objects in memory:");
        for (Object o : ksession.getObjects()) {
            System.out.println(o);
        }
         /**/

        System.out.println("Finished...");
    }


}
